package cz.muni.fi.pb162.comparable;

import java.util.Comparator;

/**
 * Trieda CarProductionYearComparator slúži na porovnanie objektov triedy Car podľa roku výroby vozidla
 * Trieda Car ma prirodzené usporiadanie podľa ŠPZ vozdila
 * Pomocou Comparatoru ako je táto trieda tak vieme získať usporiadanie podľa iného atribútu
 */
public class CarProductionYearComparator implements Comparator<Car> {

    // metóda compare má rovnaké možnosti návratovej hodnoty ako metóda compareTo z rozhrania Comparable
    // ak je výsledok:
    //      1. záporný tak car1 bude v usporiadanej kolekcii pred car2
    //      2. 0 tak car1 bude bezprostredne pred car2, poprípade bude tam len jeden objekt (ak metóda equals vráti 0)
    //      3. kladný tak car1 bude v usporiadanej kolekcii za car2
    @Override
    public int compare(Car car1, Car car2) {
        return car1.getYearOfProduction() - car2.getYearOfProduction();
    }
}
class CarProductionYearComparatorDesc implements Comparator<Car> {

    @Override
    public int compare(Car car1, Car car2) {
        return car2.getYearOfProduction() - car1.getYearOfProduction();
    }
}
