package cz.muni.fi.pb162.generics;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

/**
 * Táto trieda je príkladom jednoduchej generickej triedy
 * Predstavuje zjednodušenú databázovú tabuľku
 * @param <T> typ tabulky, ktorý si zvolíme pri jej vytvorení
 */
public class DatabaseTable<T> {
    // generický atribút
    // pri vytvorení inštancie tejto triedy získa tento atribút konkrétny typ
    // ak vytvoríme DatabaseTable<String> -> atribút bude typu List<String>
    private List<T> data = new ArrayList<>();

    // generické metódy
    public Collection<T> getAll() {
        return Collections.unmodifiableList(data);
    }

    public T getFromIndex(int index) {
        return data.get(index);
    }

    public boolean contains(T object) {
        return data.contains(object);
    }

    public void add(T object) {
        data.add(object);
    }

    public void remove(T object) {
        data.remove(object);
    }

    public void removeAll() {
        data.clear();
    }
}
